
/**
 * Class Node. 
 * 
 * @version (a version number or a date)
 *
 * @author Andrea Valente
 * Member of <br><b>T</b>he <b>A</b>vatars <b>G</b>roup
 * <br>sf.net/projects/avatarsdev
 */

package sge;

import java.io.*;

class Node extends Item
				implements Serializable {
private int x,y,r,id;
static int RADIUS=5;
static int NODEID=-1;
static Node DUMMY=new Node();

	static private int
	makeId(){
		return NODEID++;
	}

	// Needed for serialization
	Node(){
		this(0,0,RADIUS);
	}
	
	Node(int posX,int posY){
		this(posX,posY,RADIUS);
	}
	
	// The MAIN constructor
	Node(int posX,int posY,int radius){
		id = makeId();
		setPosition(posX,posY);
		r=radius;
	}

	public String
	toString(){
      return "N_"+id+"("+x+","+y+")";
	}

	public void
	setPosition(int x,int y){
		this.x=x;
		this.y=y;
	}
	
	// To be used only for the DUMMY object.
	public void
	setId(int id){
		this.id=id;
	}
	
	public int
	getX(){
		return x;
	}

	public int
	getY(){
		return y;
	}

	public int
	getRadius(){
		return r;
	}

	public int
	getId(){
		return id;
	}

	public int
	getW(){
		return r*2;
	}

	public int
	getH(){
		return r*2;
	}
	
	public boolean
	isInside(int px,int py){
		int cx=x+r,cy=y+r;
		int xx=cx-px,yy=cy-py;
		xx*=xx;
		yy*=yy;
		return ( ((xx+yy)<=(r*r)) );
	}

	public boolean
	equals(Object o){
		Node n=(Node)o;
		return (n.id==id);
	}
}
	
