package sge;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;
import java.net.URL;
import java.net.URLClassLoader;
import java.beans.*;

public class SGE {
	public static void 
	main(String[] a){
		new SGE();
	}

JGraphEditor ge=null;

	public 
	SGE(){
		JFrame f=new JFrame("SGE");
		f.addWindowListener( new WindowAdapter(){
			public void windowClosing(WindowEvent e){
			System.exit(0);
			}
		});

		f.getContentPane().setLayout(new BorderLayout());
		((JComponent) (f.getContentPane())).setBorder(new EtchedBorder());
		
		f.getContentPane().add( createMenuBar(), BorderLayout.NORTH);
		f.getContentPane().add( createToolBar(), BorderLayout.EAST);
		f.getContentPane().add( createJGraphEditor() , BorderLayout.CENTER);
		StatusBar statusBar = new StatusBar();
		f.getContentPane().add( statusBar, BorderLayout.SOUTH);

		f.setLocation(100,100);
		f.setSize(400,300);
		f.setVisible(true);
	}

	private JMenuBar 
	createMenuBar() {
		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
		JMenuBar menuBar = new JMenuBar();
		  
		JMenu options=(JMenu) menuBar.add(new JMenu("File"));
		for(int i=0;i<defaultActions.length;i++){
			if (defaultActions[i]==null){
				options.add( new JSeparator() );
			} else {
				JMenuItem mi=new JMenuItem( defaultActions[i].getName() );
				mi.setActionCommand("action"+i);
				mi.addActionListener(defaultActions[i]);
				mi.setEnabled(defaultActions[i].isEnabled());
				options.add( mi );
			}
		}
		options.add(new JSeparator());
		return menuBar;
	}

	/**
	 * Get images from its JAR-file.
	 */
	private Image
	fetchImage(String name,JPanel p){
		Image img = null;
		URLClassLoader urlLoader = (URLClassLoader)this.getClass().getClassLoader();
		URL fileLoc = urlLoader.findResource("images/" + name);
		img = p.getToolkit().createImage(fileLoc);
		return img;
	}

	public JButton 
	createImageButton(ImageIcon img,String tip){
		JButton b = null;
		b = new JButton( img );
		b.setBackground(Color.lightGray);
		b.setToolTipText(tip);
		b.setPreferredSize(new Dimension(22, 22));
		b.setMaximumSize(new Dimension(22, 22));
		b.setMinimumSize(new Dimension(22, 22));

		b.setSelected(true);
		return b;
    }

	private ImageIcon stopIcon, startIcon;

	private JPanel
	createToolBar(){
		JPanel toolPan=new JPanel();

		toolPan.setLayout(  new GridLayout( defaultActions.length , 1 )  );
		toolPan.setBackground( Color.gray );

		for(int i=0;i<defaultActions.length;i++){
			if (defaultActions[i]!=null){
				String iconName=defaultActions[i].getIconName();
				String descr=defaultActions[i].getName();
				JButton b=null;
				if (iconName==null){
					b=new JButton( descr );
				}else {
					b=createImageButton( new ImageIcon( 
													fetchImage(iconName,toolPan), 
													descr),
												descr );
				}
				b.addActionListener( defaultActions[i] );
				toolPan.add( b );
			} else { // Separator between actions
				toolPan.add(new JPanel());
			}
		}
		return toolPan;
	}

	public JPanel
	createPalette(){
		JPanel p=new JPanel();
			p.add(new JLabel("Rules") );
			p.setBackground( Color.blue );
		return p;
	}

	public JComponent
	createJGraphEditor(){
		ge=new JGraphEditor();
		JScrollPane scroller = new JScrollPane();
		scroller.setVerticalScrollBarPolicy(
			JScrollPane.VERTICAL_SCROLLBAR_ALWAYS );
		scroller.setHorizontalScrollBarPolicy(
			JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS );
		JViewport port = scroller.getViewport();
		port.add( ge );
		return scroller;
	}
	
	private MyAction[] defaultActions = {
		new LoadGraphAction(),
		new SaveGraphAction(),
		null,
		new NewNodeAction(),
		new DelNodeAction(),
		new NewArcModeAction(),
		new DelArcAction(),
		null,
		new ExitAction()
	};

// ----------------------- Actions ---------------------------
	
	abstract class MyAction extends AbstractAction{
		MyAction(String s){
			super(s);
		}
	
		String name="MyAction";
		public String
		getName(){
			return name;
		}

		String in=null;
		public String
		getIconName(){
			return in;
		}
	}

	/**
	 * Really lame implementation of an exit command
	 */
	class ExitAction extends MyAction {
		ExitAction() {
			super("exitAction");
			name="exit";
			in="exit.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			System.exit(0);
		}
	}


	class NewNodeAction extends MyAction {
		NewNodeAction() {
			super("newNodeAction");
			name="newNode";
			in="newnode.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.newNode();
		}
	}

	
	class DelNodeAction extends MyAction {
		DelNodeAction() {
			super("DelNodeAction");
			name="delNode";
			in="delnode.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.delNode();
		}
	}

	class LoadGraphAction extends MyAction {
		LoadGraphAction() {
			super("loadGraphAction");
			name="load";
			in="open.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.loadGraph();
		}
	}
	
	class SaveGraphAction extends MyAction {
		SaveGraphAction() {
			super("saveGraphAction");
			name="save";
			in="save.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.saveGraph();
		}
	}
	
	class NewArcModeAction extends MyAction {
		NewArcModeAction() {
			super("NewArcMode");
			name="newArcMode";
			in="newarc.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.newArcMode();
		}
	}

	class DelArcAction extends MyAction {
		DelArcAction() {
			super("DelArc");
			name="delArc";
			in="delarc.gif";
		}

		public void 
		actionPerformed(ActionEvent e) {
			ge.delArc();
		}
	}

}
